Index: trunk/src/kernel32/console.cpp
===================================================================
--- trunk/src/kernel32/console.cpp	(revision 5065)
+++ trunk/src/kernel32/console.cpp	(revision 5070)
@@ -1,3 +1,3 @@
-/* $Id: console.cpp,v 1.24 2001-01-29 00:43:33 bird Exp $ */
+/* $Id: console.cpp,v 1.25 2001-02-08 10:23:40 sandervl Exp $ */
 
 /*
@@ -434,28 +434,13 @@
 
 
-  /***********************************************************************
-   * initialize stdin handle                                             *
-   ***********************************************************************/
-  hStandardIn = GetStdHandle(STD_INPUT_HANDLE);
-  dwType = GetFileType(hStandardIn);
-  if (dwType == FILE_TYPE_CHAR)                /* is handle redirected ? */
-    hStandardIn = HMCreateFile("CONIN$",
-                               GENERIC_READ | GENERIC_WRITE,
-                               FILE_SHARE_READ | FILE_SHARE_WRITE,
-                               NULL,
-                               0,
-                               CONSOLE_TEXTMODE_BUFFER,
-                               0);
-
-  HMSetStdHandle(STD_INPUT_HANDLE,
-                 hStandardIn);
-
-  /***********************************************************************
-   * initialize stdout handle                                            *
-   ***********************************************************************/
-  hStandardOut = GetStdHandle(STD_OUTPUT_HANDLE);
-  dwType = GetFileType(hStandardOut);
-  if (dwType == FILE_TYPE_CHAR)                /* is handle redirected ? */
-    hStandardOut = HMCreateFile("CONOUT$",
+  if(flVioConsole == FALSE)
+  {
+   /***********************************************************************
+    * initialize stdin handle                                             *
+    ***********************************************************************/
+   hStandardIn = GetStdHandle(STD_INPUT_HANDLE);
+   dwType = GetFileType(hStandardIn);
+   if (dwType == FILE_TYPE_CHAR)                /* is handle redirected ? */
+     hStandardIn = HMCreateFile("CONIN$",
                                 GENERIC_READ | GENERIC_WRITE,
                                 FILE_SHARE_READ | FILE_SHARE_WRITE,
@@ -464,24 +449,42 @@
                                 CONSOLE_TEXTMODE_BUFFER,
                                 0);
-
-  HMSetStdHandle(STD_OUTPUT_HANDLE,
-                 hStandardOut);
-
-  /***********************************************************************
-   * initialize stderr handle                                            *
-   ***********************************************************************/
-  hStandardError = GetStdHandle(STD_ERROR_HANDLE);
-  dwType = GetFileType(hStandardError);
-  if (dwType == FILE_TYPE_CHAR)                /* is handle redirected ? */
-    hStandardError = HMCreateFile("CONOUT$",
-                                  GENERIC_READ | GENERIC_WRITE,
-                                  FILE_SHARE_READ | FILE_SHARE_WRITE,
-                                  NULL,
-                                  0,
-                                  CONSOLE_TEXTMODE_BUFFER,
-                                  0);
-
-  HMSetStdHandle(STD_ERROR_HANDLE,
-                 hStandardError);
+ 
+   HMSetStdHandle(STD_INPUT_HANDLE,
+                  hStandardIn);
+ 
+   /***********************************************************************
+    * initialize stdout handle                                            *
+    ***********************************************************************/
+   hStandardOut = GetStdHandle(STD_OUTPUT_HANDLE);
+   dwType = GetFileType(hStandardOut);
+   if (dwType == FILE_TYPE_CHAR)                /* is handle redirected ? */
+     hStandardOut = HMCreateFile("CONOUT$",
+                                 GENERIC_READ | GENERIC_WRITE,
+                                 FILE_SHARE_READ | FILE_SHARE_WRITE,
+                                 NULL,
+                                 0,
+                                 CONSOLE_TEXTMODE_BUFFER,
+                                 0);
+ 
+   HMSetStdHandle(STD_OUTPUT_HANDLE,
+                  hStandardOut);
+ 
+   /***********************************************************************
+    * initialize stderr handle                                            *
+    ***********************************************************************/
+   hStandardError = GetStdHandle(STD_ERROR_HANDLE);
+   dwType = GetFileType(hStandardError);
+   if (dwType == FILE_TYPE_CHAR)                /* is handle redirected ? */
+     hStandardError = HMCreateFile("CONOUT$",
+                                   GENERIC_READ | GENERIC_WRITE,
+                                   FILE_SHARE_READ | FILE_SHARE_WRITE,
+                                   NULL,
+                                   0,
+                                   CONSOLE_TEXTMODE_BUFFER,
+                                   0);
+ 
+   HMSetStdHandle(STD_ERROR_HANDLE,
+                  hStandardError);
+  }
 
   return (NO_ERROR);                                                   /* OK */
Index: trunk/src/kernel32/exceptutil.asm
===================================================================
--- trunk/src/kernel32/exceptutil.asm	(revision 5065)
+++ trunk/src/kernel32/exceptutil.asm	(revision 5070)
@@ -1,3 +1,3 @@
-; $Id: exceptutil.asm,v 1.11 2000-09-08 18:07:49 sandervl Exp $
+; $Id: exceptutil.asm,v 1.12 2001-02-08 10:23:40 sandervl Exp $
 
 ;/*
@@ -53,10 +53,4 @@
 
 _RtlUnwind@16 proc near
-        ; fudge return address
-        push eax
-        mov  eax, dword ptr [esp+12]
-        mov  dword ptr [esp+4], eax
-        pop  eax
-
         push dword ptr [esp+4]  ;PWINEXCEPTION_FRAME  pEndFrame
         push dword ptr [esp+12] ;LPVOID unusedEip